      subroutine eight_symmetry(theta_symm, phi_symm, omega_symm,
     $     angles_deg)

C     For a given orientation (angles_deg), generate the full set of
C     eight symmetry related orientations

      implicit none

      real, intent(out) :: theta_symm(8), phi_symm(8), omega_symm(8)
      real, intent(in)  :: angles_deg(3)

      integer i

      do i = 1, 4
         theta_symm(i) = angles_deg(1)
         phi_symm(i)   = angles_deg(2) + real(i-1)*90.0
         omega_symm(i) = angles_deg(3)
      enddo
      
      do i = 5, 8
         theta_symm(i) = -angles_deg(1) + 180.0
         phi_symm(i)   = -angles_deg(2) + 90.0 + real(i-5)*90.0
         omega_symm(i) =  angles_deg(3) + 180.0
      enddo

      do i = 1, 8
         phi_symm(i) = mod(phi_symm(i), 360.0)
      enddo

      do i = 1, 8
         if (phi_symm(i) > 180.0) then
            phi_symm(i) = phi_symm(i) - 360.0
         endif
      enddo

      return
      end subroutine eight_symmetry
