      subroutine map_peak_restr (map, ncol, nrow, ipeakx, ipeaky, peak,
     $     lpeakx, lpeaky, lpeak, incx, incy, excx, excy)

C     Routine to search for the highest peak in a 2d map section.
C      
C     ipeakx = column position of "peak"
C     ipeaky = row position of "peak"
C     peak   = intensity of "peak"
C     lpeakx = column position of "peak"
C     lpeaky = row position of "peak"
C     lpeak   = intensity of "peak"
C      
C     may 1992  purdue university vax 8550, t. baker
C     modified 28-may-1992 by t. baker
C     last modified 09-dec-2003 by misha/rob - search restricted
C     7-Jul-2006, General cleanup and move call to rearrange_fft_style
C       into pftcc_peak
      
      implicit none
      
      integer*4, intent(in)    :: ncol, nrow
      integer*4, intent(in)    :: incx, incy, excx, excy
      real*4,    intent(in)    :: map(ncol,nrow)

      integer*4, intent(out)   :: ipeakx, ipeaky
      integer*4, intent(out)   :: lpeakx, lpeaky
      real*4,    intent(out)   :: peak, lpeak

      integer*4 i, j
      integer*4 beginx, endx, beginy, endy, cenx, ceny
      
      peak  = -huge(peak)
      lpeak = -huge(peak)
      
      ceny = ((nrow+1)/2)
      cenx = ((ncol+1)/2)

      beginx = cenx-incx
      endx   = cenx+incx
      beginy = ceny-incy
      endy   = ceny+incy

      do j = beginy,endy
         do i = beginx,endx
            if(map(i,j).gt.peak) then
               ipeakx = i
               ipeaky = j
               peak   = map(i,j)
            endif
         enddo
      enddo

      beginx = excx
      endx   = ncol - excx
      beginy = excy
      endy   = nrow-excy

      do j = beginy,endy
         do i = beginx,endx
            if(map(i,j).gt.lpeak) then
               lpeakx = i
               lpeaky = j
               lpeak  = map(i,j)
            endif
         enddo
      enddo

      return
      end subroutine map_peak_restr
