      SUBROUTINE PRJAVG_FFT (PRJ_AVG, NCOL, NROW, NVIEW_MOD, FFT, IDIM1,
     $     IDIM2, MODE, PRJHEAD)

C     Calculate Fourier transform of the circularly averaged
C     projection. If mode<0, then projection must be read in from disk.
C
C     MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.
C     MODIFIED 15-DEC-1997 BY T. BAKER (Rid of EM.CMM).
C     MODIFIED 23-DEC-1997 BY T. BAKER (Memory version of PRJ_AVG).
C     MODIFIED 14-JAN-1998 BY TSB/RWA (.PIF input of PRJ_AVG).
C     MODIFIED  6-MAR-1998 BY TSB (Make UNIX compatible).
C     MODIFIED 21-APR-1998 BY T. BAKER (Renamed from PFTCC_AVGFFT).
C     Modified 21-aug-2006, R Sinkovits, minor cleanup and modernization

      IMPLICIT NONE

      INCLUDE '../include/pifhead.inc'
      TYPE (PIFHEAD_T) PRJHEAD

      INTEGER*4, INTENT(IN) :: NCOL, NROW, NVIEW_MOD, IDIM1, IDIM2, MODE
      REAL*4, INTENT(INOUT) :: PRJ_AVG(NCOL,NROW)
      REAL*4, INTENT(OUT)   :: FFT(2*IDIM1,IDIM2)

      INTEGER*4 SECNUM

C     If mode<0, then read in data store on disk. The average projection
C     is the NVIEW_MOD + 1 projection stored in the PIF file

      IF(MODE < 0) THEN
        PRJ_AVG = 0.0 ! f90 array syntax
        SECNUM = NVIEW_MOD + 1
        CALL PIF_READ_SECI4 (PRJHEAD, PRJ_AVG, NCOL, NROW, SECNUM)
      ENDIF

      CALL MAP_FFT_FILL (PRJ_AVG, NCOL, NROW, FFT, IDIM1, IDIM2, 0.0)
      CALL FFT_2D (FFT, IDIM1, IDIM2)

      RETURN
      END SUBROUTINE PRJAVG_FFT
